Index: issm/trunk-jpl/src/c/classes/Elements/Penta.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Penta.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Elements/Penta.cpp	(revision 15564)
@@ -7649,5 +7649,5 @@
 	int         approximation,analysis_type;
 	IssmDouble  Jdet,Jdet2d;
-	IssmDouble  stokesreconditioning;
+	IssmDouble  FSreconditioning;
 	IssmDouble	bed_normal[3];
 	IssmDouble  epsilon[6]; /* epsilon=[exx,eyy,ezz,exy,exz,eyz];*/
@@ -7664,15 +7664,15 @@
 	if(!IsOnBed() || IsFloating()) return NULL;
 	inputs->GetInputValue(&approximation,ApproximationEnum);
-	if(approximation!=PattynStokesApproximationEnum) return NULL;
-	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,StokesApproximationEnum);
+	if(approximation!=HOFSApproximationEnum) return NULL;
+	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,FSApproximationEnum);
 
 	/*Retrieve all inputs and parameters*/
 	GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
 	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
-	this->parameters->FindParam(&stokesreconditioning,DiagnosticStokesreconditioningEnum);
+	this->parameters->FindParam(&FSreconditioning,DiagnosticFSreconditioningEnum);
 	Input* vx_input=inputs->GetInput(VxEnum);               _assert_(vx_input);
 	Input* vy_input=inputs->GetInput(VyEnum);               _assert_(vy_input);
 	Input* vz_input=inputs->GetInput(VzEnum);               _assert_(vz_input);
-	Input* vzpattyn_input=inputs->GetInput(VzPattynEnum);   _assert_(vzpattyn_input);
+	Input* vzHO_input=inputs->GetInput(VzHOEnum);   _assert_(vzHO_input);
 
 	for(i=0;i<NUMVERTICES2D;i++) for(j=0;j<3;j++) xyz_list_tria[i][j]=xyz_list[i][j];
@@ -7690,10 +7690,10 @@
 		GetNodalFunctionsP1(basis, gauss);
 
-		vzpattyn_input->GetInputValue(&w, gauss);
-		vzpattyn_input->GetInputDerivativeValue(&dw[0],&xyz_list[0][0],gauss);
+		vzHO_input->GetInputValue(&w, gauss);
+		vzHO_input->GetInputDerivativeValue(&dw[0],&xyz_list[0][0],gauss);
 
 		BedNormal(&bed_normal[0],xyz_list_tria);
 		this->GetStrainRate3d(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input,vz_input);
-		material->GetViscosity3dStokes(&viscosity,&epsilon[0]);
+		material->GetViscosity3dFS(&viscosity,&epsilon[0]);
 		friction->GetAlpha2(&alpha2_gauss, gauss,VxEnum,VyEnum,VzEnum);
 
@@ -7723,20 +7723,20 @@
 		case MacAyealApproximationEnum:
 			return CreatePVectorDiagnosticMacAyeal();
-		case PattynApproximationEnum:
-			return CreatePVectorDiagnosticPattyn();
+		case HOApproximationEnum:
+			return CreatePVectorDiagnosticHO();
 		case L1L2ApproximationEnum:
 			return CreatePVectorDiagnosticL1L2();
-		case HutterApproximationEnum:
+		case SIAApproximationEnum:
 			return NULL;
 		case NoneApproximationEnum:
 			return NULL;
-		case StokesApproximationEnum:
-			return CreatePVectorDiagnosticStokes();
-		case MacAyealPattynApproximationEnum:
-			return CreatePVectorDiagnosticMacAyealPattyn();
-		case MacAyealStokesApproximationEnum:
-			return CreatePVectorDiagnosticMacAyealStokes();
-		case PattynStokesApproximationEnum:
-			return CreatePVectorDiagnosticPattynStokes();
+		case FSApproximationEnum:
+			return CreatePVectorDiagnosticFS();
+		case MacAyealHOApproximationEnum:
+			return CreatePVectorDiagnosticMacAyealHO();
+		case MacAyealFSApproximationEnum:
+			return CreatePVectorDiagnosticMacAyealFS();
+		case HOFSApproximationEnum:
+			return CreatePVectorDiagnosticHOFS();
 		default:
 			_error_("Approximation " << EnumToStringx(approximation) << " not supported yet");
@@ -7744,10 +7744,10 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticMacAyealPattyn{{{*/
-ElementVector* Penta::CreatePVectorDiagnosticMacAyealPattyn(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticMacAyealHO{{{*/
+ElementVector* Penta::CreatePVectorDiagnosticMacAyealHO(void){
 
 	/*compute all load vectors for this element*/
 	ElementVector* pe1=CreatePVectorDiagnosticMacAyeal();
-	ElementVector* pe2=CreatePVectorDiagnosticPattyn();
+	ElementVector* pe2=CreatePVectorDiagnosticHO();
 	ElementVector* pe =new ElementVector(pe1,pe2);
 
@@ -7758,11 +7758,11 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticMacAyealStokes{{{*/
-ElementVector* Penta::CreatePVectorDiagnosticMacAyealStokes(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticMacAyealFS{{{*/
+ElementVector* Penta::CreatePVectorDiagnosticMacAyealFS(void){
 
 	/*compute all load vectors for this element*/
 	ElementVector* pe1=CreatePVectorDiagnosticMacAyeal();
-	ElementVector* pe2=CreatePVectorDiagnosticStokes();
-	ElementVector* pe3=CreatePVectorCouplingMacAyealStokes();
+	ElementVector* pe2=CreatePVectorDiagnosticFS();
+	ElementVector* pe3=CreatePVectorCouplingMacAyealFS();
 	ElementVector* pe =new ElementVector(pe1,pe2,pe3);
 
@@ -7774,11 +7774,11 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticPattynStokes{{{*/
-ElementVector* Penta::CreatePVectorDiagnosticPattynStokes(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticHOFS{{{*/
+ElementVector* Penta::CreatePVectorDiagnosticHOFS(void){
 
 	/*compute all load vectors for this element*/
-	ElementVector* pe1=CreatePVectorDiagnosticPattyn();
-	ElementVector* pe2=CreatePVectorDiagnosticStokes();
-	ElementVector* pe3=CreatePVectorCouplingPattynStokes();
+	ElementVector* pe1=CreatePVectorDiagnosticHO();
+	ElementVector* pe2=CreatePVectorDiagnosticFS();
+	ElementVector* pe3=CreatePVectorCouplingHOFS();
 	ElementVector* pe =new ElementVector(pe1,pe2,pe3);
 
@@ -7790,6 +7790,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticHutter{{{*/
-ElementVector* Penta::CreatePVectorDiagnosticHutter(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticSIA{{{*/
+ElementVector* Penta::CreatePVectorDiagnosticSIA(void){
 
 	/*Intermediaries*/
@@ -7903,10 +7903,10 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticPattyn{{{*/
-ElementVector* Penta::CreatePVectorDiagnosticPattyn(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticHO{{{*/
+ElementVector* Penta::CreatePVectorDiagnosticHO(void){
 
 	/*compute all load vectors for this element*/
-	ElementVector* pe1=CreatePVectorDiagnosticPattynDrivingStress();
-	ElementVector* pe2=CreatePVectorDiagnosticPattynFront();
+	ElementVector* pe1=CreatePVectorDiagnosticHODrivingStress();
+	ElementVector* pe2=CreatePVectorDiagnosticHOFront();
 	ElementVector* pe =new ElementVector(pe1,pe2);
 
@@ -7917,6 +7917,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticPattynDrivingStress{{{*/
-ElementVector* Penta::CreatePVectorDiagnosticPattynDrivingStress(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticHODrivingStress{{{*/
+ElementVector* Penta::CreatePVectorDiagnosticHODrivingStress(void){
 
 	/*Constants*/
@@ -7933,5 +7933,5 @@
 
 	/*Initialize Element vector*/
-	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,PattynApproximationEnum);
+	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,HOApproximationEnum);
 
 	/*Retrieve all inputs and parameters*/
@@ -7965,6 +7965,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticPattynFront{{{*/
-ElementVector* Penta::CreatePVectorDiagnosticPattynFront(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticHOFront{{{*/
+ElementVector* Penta::CreatePVectorDiagnosticHOFront(void){
 
 	/*Intermediaries */
@@ -8000,5 +8000,5 @@
 
 	GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	ElementVector* pe=new ElementVector(nodes,numnodes,this->parameters,PattynApproximationEnum);
+	ElementVector* pe=new ElementVector(nodes,numnodes,this->parameters,HOApproximationEnum);
 	Input* surface_input=inputs->GetInput(SurfaceEnum); _assert_(surface_input);
 	rho_water=matpar->GetRhoWater();
@@ -8043,31 +8043,31 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticStokes {{{*/
-ElementVector* Penta::CreatePVectorDiagnosticStokes(void){
-
-	int fe_stokes;
+/*FUNCTION Penta::CreatePVectorDiagnosticFS {{{*/
+ElementVector* Penta::CreatePVectorDiagnosticFS(void){
+
+	int fe_FS;
 	ElementVector* pe1;
 	ElementVector* pe2;
 	ElementVector* pe3;
 	ElementVector* pe;
-	parameters->FindParam(&fe_stokes,FlowequationFeStokesEnum);
-
-	switch(fe_stokes){
+	parameters->FindParam(&fe_FS,FlowequationFeFSEnum);
+
+	switch(fe_FS){
 		case 0:
 			/*compute all stiffness matrices for this element*/
-			pe1=CreatePVectorDiagnosticStokesViscous();
-			pe2=CreatePVectorDiagnosticStokesShelf();
-			pe3=CreatePVectorDiagnosticStokesFront();
+			pe1=CreatePVectorDiagnosticFSViscous();
+			pe2=CreatePVectorDiagnosticFSShelf();
+			pe3=CreatePVectorDiagnosticFSFront();
 			pe =new ElementVector(pe1,pe2,pe3);
 			break;
 		case 1:
 			/*compute all stiffness matrices for this element*/
-			pe1=CreatePVectorDiagnosticStokesGLSViscous();
-			pe2=CreatePVectorDiagnosticStokesShelf();
-			pe3=CreatePVectorDiagnosticStokesFront();
+			pe1=CreatePVectorDiagnosticFSGLSViscous();
+			pe2=CreatePVectorDiagnosticFSShelf();
+			pe3=CreatePVectorDiagnosticFSFront();
 			pe =new ElementVector(pe1,pe2,pe3);
 			break;
 		default:
-			_error_("Finite element" << fe_stokes << " not supported yet");
+			_error_("Finite element" << fe_FS << " not supported yet");
 	}
 
@@ -8080,6 +8080,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticStokesViscous {{{*/
-ElementVector* Penta::CreatePVectorDiagnosticStokesViscous(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticFSViscous {{{*/
+ElementVector* Penta::CreatePVectorDiagnosticFSViscous(void){
 
 	/*Constants*/
@@ -8090,5 +8090,5 @@
 	int        approximation;
 	IssmDouble Jdet,viscosity;
-	IssmDouble gravity,rho_ice,stokesreconditioning;
+	IssmDouble gravity,rho_ice,FSreconditioning;
 	IssmDouble forcex,forcey,forcez;
 	IssmDouble xyz_list[NUMVERTICES][3];
@@ -8106,9 +8106,9 @@
 	/*Initialize Element vector and return if necessary*/
 	inputs->GetInputValue(&approximation,ApproximationEnum);
-	if(approximation!=StokesApproximationEnum && approximation!=MacAyealStokesApproximationEnum && approximation!=PattynStokesApproximationEnum) return NULL;
-	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,StokesApproximationEnum);
+	if(approximation!=FSApproximationEnum && approximation!=MacAyealFSApproximationEnum && approximation!=HOFSApproximationEnum) return NULL;
+	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,FSApproximationEnum);
 
 	/*Retrieve all inputs and parameters*/
-	this->parameters->FindParam(&stokesreconditioning,DiagnosticStokesreconditioningEnum);
+	this->parameters->FindParam(&FSreconditioning,DiagnosticFSreconditioningEnum);
 	rho_ice=matpar->GetRhoIce();
 	gravity=matpar->GetG();
@@ -8128,10 +8128,10 @@
 
 		GetJacobianDeterminant(&Jdet, &xyz_list[0][0],gauss);
-		GetBStokes(&B[0][0],&xyz_list[0][0],gauss); 
-		GetBprimeStokes(&B_prime[0][0],&xyz_list[0][0], gauss); 
+		GetBFS(&B[0][0],&xyz_list[0][0],gauss); 
+		GetBprimeFS(&B_prime[0][0],&xyz_list[0][0], gauss); 
 		GetNodalFunctionsMINI(&l1l7[0], gauss);
 
 		this->GetStrainRate3d(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input,vz_input);
-		material->GetViscosity3dStokes(&viscosity,&epsilon[0]);
+		material->GetViscosity3dFS(&viscosity,&epsilon[0]);
 
 		loadingforcex_input->GetInputValue(&forcex, gauss);
@@ -8151,5 +8151,5 @@
 		D_scalar=gauss->weight*Jdet;
 		for (i=0;i<6;i++) D[i][i]=D_scalar*2*viscosity;
-		for (i=6;i<8;i++) D[i][i]=-D_scalar*stokesreconditioning;
+		for (i=6;i<8;i++) D[i][i]=-D_scalar*FSreconditioning;
 
 		TripleMultiply(&B[0][0],8,numdofbubble,1,
@@ -8160,5 +8160,5 @@
 
 	/*Condensation*/
-	ReduceVectorStokes(pe->values, &Ke_temp[0][0], &Pe_gaussian[0]);
+	ReduceVectorFS(pe->values, &Ke_temp[0][0], &Pe_gaussian[0]);
 
 	/*Transform coordinate system*/
@@ -8170,6 +8170,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticStokesFront{{{*/
-ElementVector* Penta::CreatePVectorDiagnosticStokesFront(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticFSFront{{{*/
+ElementVector* Penta::CreatePVectorDiagnosticFSFront(void){
 
 	/*Intermediaries */
@@ -8205,5 +8205,5 @@
 
 	GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	ElementVector* pe=new ElementVector(nodes,numnodes,this->parameters,StokesApproximationEnum);
+	ElementVector* pe=new ElementVector(nodes,numnodes,this->parameters,FSApproximationEnum);
 	rho_water=matpar->GetRhoWater();
 	rho_ice  =matpar->GetRhoIce();
@@ -8247,6 +8247,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticStokesGLSViscous {{{*/
-ElementVector* Penta::CreatePVectorDiagnosticStokesGLSViscous(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticFSGLSViscous {{{*/
+ElementVector* Penta::CreatePVectorDiagnosticFSGLSViscous(void){
 
 	/*Constants*/
@@ -8257,5 +8257,5 @@
 	int        approximation;
 	IssmDouble Jdet,gravity,rho_ice,B,D_scalar_stab,viscosity;
-	IssmDouble forcex,forcey,forcez,diameter,stokesreconditioning;
+	IssmDouble forcex,forcey,forcez,diameter,FSreconditioning;
 	IssmDouble xyz_list[NUMVERTICES][3];
 	IssmDouble epsilon[6]; /* epsilon=[exx,eyy,ezz,exy,exz,eyz];*/
@@ -8276,7 +8276,7 @@
 	/*Initialize Element vector and return if necessary*/
 	inputs->GetInputValue(&approximation,ApproximationEnum);
-	if(approximation!=StokesApproximationEnum && approximation!=MacAyealStokesApproximationEnum && approximation!=PattynStokesApproximationEnum) return NULL;
-	parameters->FindParam(&stokesreconditioning,DiagnosticStokesreconditioningEnum);
-	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,StokesApproximationEnum);
+	if(approximation!=FSApproximationEnum && approximation!=MacAyealFSApproximationEnum && approximation!=HOFSApproximationEnum) return NULL;
+	parameters->FindParam(&FSreconditioning,DiagnosticFSreconditioningEnum);
+	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,FSApproximationEnum);
 
 	/*Retrieve all inputs and parameters*/
@@ -8318,5 +8318,5 @@
 		GetNodalFunctionsP1(&l1l6[0], gauss);
 		this->GetStrainRate3d(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input,vz_input);
-		material->GetViscosity3dStokes(&viscosity,&epsilon[0]);
+		material->GetViscosity3dFS(&viscosity,&epsilon[0]);
 
 		loadingforcex_input->GetInputValue(&forcex, gauss);
@@ -8372,6 +8372,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreatePVectorDiagnosticStokesShelf{{{*/
-ElementVector* Penta::CreatePVectorDiagnosticStokesShelf(void){
+/*FUNCTION Penta::CreatePVectorDiagnosticFSShelf{{{*/
+ElementVector* Penta::CreatePVectorDiagnosticFSShelf(void){
 
 	/*Intermediaries*/
@@ -8392,6 +8392,6 @@
 	inputs->GetInputValue(&approximation,ApproximationEnum);
 	this->parameters->FindParam(&shelf_dampening,DiagnosticShelfDampeningEnum);
-	if(approximation!=StokesApproximationEnum && approximation!=MacAyealStokesApproximationEnum && approximation!=PattynStokesApproximationEnum) return NULL;
-	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,StokesApproximationEnum);
+	if(approximation!=FSApproximationEnum && approximation!=MacAyealFSApproximationEnum && approximation!=HOFSApproximationEnum) return NULL;
+	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,FSApproximationEnum);
 
 	/*Retrieve all inputs and parameters*/
@@ -8477,7 +8477,7 @@
 	Input* vx_input=inputs->GetInput(VxEnum); _assert_(vx_input);
 	Input* vy_input=inputs->GetInput(VyEnum); _assert_(vy_input);
-	Input* vzstokes_input=NULL;
-	if(approximation==PattynStokesApproximationEnum || approximation==MacAyealStokesApproximationEnum){
-		vzstokes_input=inputs->GetInput(VzStokesEnum); _assert_(vzstokes_input);
+	Input* vzFS_input=NULL;
+	if(approximation==HOFSApproximationEnum || approximation==MacAyealFSApproximationEnum){
+		vzFS_input=inputs->GetInput(VzFSEnum); _assert_(vzFS_input);
 	}
 
@@ -8493,6 +8493,6 @@
 		vx_input->GetInputDerivativeValue(&du[0],&xyz_list[0][0],gauss);
 		vy_input->GetInputDerivativeValue(&dv[0],&xyz_list[0][0],gauss);
-		if(approximation==PattynStokesApproximationEnum || approximation==MacAyealStokesApproximationEnum){
-			vzstokes_input->GetInputDerivativeValue(&dw[0],&xyz_list[0][0],gauss);
+		if(approximation==HOFSApproximationEnum || approximation==MacAyealFSApproximationEnum){
+			vzFS_input->GetInputDerivativeValue(&dw[0],&xyz_list[0][0],gauss);
 			dwdz=dw[2];
 		}
@@ -8539,7 +8539,7 @@
 	Input* vx_input=inputs->GetInput(VxEnum);                                  _assert_(vx_input);
 	Input* vy_input=inputs->GetInput(VyEnum);                                  _assert_(vy_input);
-	Input* vzstokes_input=NULL;
-	if(approximation==PattynStokesApproximationEnum || approximation==MacAyealStokesApproximationEnum){
-		vzstokes_input=inputs->GetInput(VzStokesEnum);       _assert_(vzstokes_input);
+	Input* vzFS_input=NULL;
+	if(approximation==HOFSApproximationEnum || approximation==MacAyealFSApproximationEnum){
+		vzFS_input=inputs->GetInput(VzFSEnum);       _assert_(vzFS_input);
 	}
 
@@ -8554,6 +8554,6 @@
 		vx_input->GetInputValue(&vx, gauss);
 		vy_input->GetInputValue(&vy, gauss);
-		if(approximation==PattynStokesApproximationEnum || approximation==MacAyealStokesApproximationEnum){
-			vzstokes_input->GetInputValue(&vz, gauss);
+		if(approximation==HOFSApproximationEnum || approximation==MacAyealFSApproximationEnum){
+			vzFS_input->GetInputValue(&vz, gauss);
 		}
 		else vz=0;
@@ -8581,9 +8581,9 @@
 	switch(approximation){
 		case MacAyealApproximationEnum:
-			return CreateJacobianDiagnosticMacayeal2d();
-		case PattynApproximationEnum:
-			return CreateJacobianDiagnosticPattyn();
-		case StokesApproximationEnum:
-			return CreateJacobianDiagnosticStokes();
+			return CreateJacobianDiagnosticSSA2d();
+		case HOApproximationEnum:
+			return CreateJacobianDiagnosticHO();
+		case FSApproximationEnum:
+			return CreateJacobianDiagnosticFS();
 		case NoneApproximationEnum:
 			return NULL;
@@ -8593,6 +8593,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreateJacobianDiagnosticMacayeal2d{{{*/
-ElementMatrix* Penta::CreateJacobianDiagnosticMacayeal2d(void){
+/*FUNCTION Penta::CreateJacobianDiagnosticSSA2d{{{*/
+ElementMatrix* Penta::CreateJacobianDiagnosticSSA2d(void){
 
 	/*Figure out if this penta is collapsed. If so, then bailout, except if it is at the 
@@ -8616,5 +8616,5 @@
 	/*Call Tria function*/
 	Tria* tria=(Tria*)SpawnTria(0,1,2); //nodes 0, 1 and 2 make the new tria.
-	ElementMatrix* Ke=tria->CreateJacobianDiagnosticMacayeal();
+	ElementMatrix* Ke=tria->CreateJacobianDiagnosticSSA();
 	delete tria->material; delete tria;
 
@@ -8627,6 +8627,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreateJacobianDiagnosticPattyn{{{*/
-ElementMatrix* Penta::CreateJacobianDiagnosticPattyn(void){
+/*FUNCTION Penta::CreateJacobianDiagnosticHO{{{*/
+ElementMatrix* Penta::CreateJacobianDiagnosticHO(void){
 
 	/*Constants*/
@@ -8645,6 +8645,6 @@
 	GaussPenta *gauss=NULL;
 
-	/*Initialize Jacobian with regular Pattyn (first part of the Gateau derivative)*/
-	ElementMatrix* Ke=CreateKMatrixDiagnosticPattyn();
+	/*Initialize Jacobian with regular HO (first part of the Gateau derivative)*/
+	ElementMatrix* Ke=CreateKMatrixDiagnosticHO();
 
 	/*Retrieve all inputs and parameters*/
@@ -8662,5 +8662,5 @@
 		GetNodalFunctionsP1Derivatives(&dphi[0][0],&xyz_list[0][0],gauss);
 
-		this->GetStrainRate3dPattyn(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input);
+		this->GetStrainRate3dHO(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input);
 		material->GetViscosityDerivativeEpsSquare(&mu_prime,&epsilon[0]);
 		eps1[0]=2*epsilon[0]+epsilon[1];   eps2[0]=epsilon[2];
@@ -8691,6 +8691,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::CreateJacobianDiagnosticStokes{{{*/
-ElementMatrix* Penta::CreateJacobianDiagnosticStokes(void){
+/*FUNCTION Penta::CreateJacobianDiagnosticFS{{{*/
+ElementMatrix* Penta::CreateJacobianDiagnosticFS(void){
 
 	/*Constants*/
@@ -8710,6 +8710,6 @@
 	GaussPenta *gauss=NULL;
 
-	/*Initialize Jacobian with regular Stokes (first part of the Gateau derivative)*/
-	ElementMatrix* Ke=CreateKMatrixDiagnosticStokes();
+	/*Initialize Jacobian with regular FS (first part of the Gateau derivative)*/
+	ElementMatrix* Ke=CreateKMatrixDiagnosticFS();
 
 	/*Retrieve all inputs and parameters*/
@@ -8728,5 +8728,5 @@
 		GetNodalFunctionsP1Derivatives(&dphi[0][0],&xyz_list[0][0],gauss);
 
-		this->GetStrainRate3dPattyn(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input);
+		this->GetStrainRate3dHO(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input);
 		material->GetViscosityDerivativeEpsSquare(&mu_prime,&epsilon[0]);
 		eps1[0]=epsilon[0];   eps2[0]=epsilon[2];   eps3[0]=epsilon[3];
@@ -8784,5 +8784,5 @@
 
 	/*If the element is a coupling, do nothing: every node is also on an other elements 
-	 * (as coupling is between MacAyeal and Pattyn) so the other element will take care of it*/
+	 * (as coupling is between MacAyeal and HO) so the other element will take care of it*/
 	GetDofList(&doflist,approximation,GsetEnum);
 
@@ -8808,6 +8808,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::GetSolutionFromInputsDiagnosticHutter{{{*/
-void  Penta::GetSolutionFromInputsDiagnosticHutter(Vector<IssmDouble>* solution){
+/*FUNCTION Penta::GetSolutionFromInputsDiagnosticSIA{{{*/
+void  Penta::GetSolutionFromInputsDiagnosticSIA(Vector<IssmDouble>* solution){
 
 	const int    numdof=NDOF2*NUMVERTICES;
@@ -8877,6 +8877,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::GetSolutionFromInputsDiagnosticStokes{{{*/
-void  Penta::GetSolutionFromInputsDiagnosticStokes(Vector<IssmDouble>* solution){
+/*FUNCTION Penta::GetSolutionFromInputsDiagnosticFS{{{*/
+void  Penta::GetSolutionFromInputsDiagnosticFS(Vector<IssmDouble>* solution){
 
 	const int    numdof=NDOF4*NUMVERTICES;
@@ -8885,10 +8885,10 @@
 	int*         doflist=NULL;
 	IssmDouble       vx,vy,vz,p;
-	IssmDouble       stokesreconditioning;
+	IssmDouble       FSreconditioning;
 	IssmDouble       values[numdof];
 	GaussPenta   *gauss;
 
 	/*Get dof list: */
-	GetDofList(&doflist,StokesApproximationEnum,GsetEnum);
+	GetDofList(&doflist,FSApproximationEnum,GsetEnum);
 	Input* vx_input=inputs->GetInput(VxEnum);       _assert_(vx_input);
 	Input* vy_input=inputs->GetInput(VyEnum);       _assert_(vy_input);
@@ -8897,5 +8897,5 @@
 
 	/*Recondition pressure: */
-	this->parameters->FindParam(&stokesreconditioning,DiagnosticStokesreconditioningEnum);
+	this->parameters->FindParam(&FSreconditioning,DiagnosticFSreconditioningEnum);
 
 	/*Ok, we have vx vy vz and P in values, fill in vx vy vz P arrays: */
@@ -8911,5 +8911,5 @@
 		values[i*NDOF4+1]=vy;
 		values[i*NDOF4+2]=vz;
-		values[i*NDOF4+3]=p/stokesreconditioning;
+		values[i*NDOF4+3]=p/FSreconditioning;
 	}
 
@@ -8961,6 +8961,6 @@
 
 	/* Get eps_b*/
-	vx_input->GetVxStrainRate3dPattyn(epsilonvx,xyz_list,gauss);
-	vy_input->GetVyStrainRate3dPattyn(epsilonvy,xyz_list,gauss);
+	vx_input->GetVxStrainRate3dHO(epsilonvx,xyz_list,gauss);
+	vy_input->GetVyStrainRate3dHO(epsilonvy,xyz_list,gauss);
 	for(i=0;i<5;i++) epsilon[i]=epsilonvx[i]+epsilonvy[i];
 	eps_b = sqrt(epsilon[0]*epsilon[0] + epsilon[1]*epsilon[1] + epsilon[0]*epsilon[1] + epsilon[2]*epsilon[2]);
@@ -9015,18 +9015,18 @@
 		return;
 	}
-	else if (approximation==PattynApproximationEnum){
-		InputUpdateFromSolutionDiagnosticPattyn(solution);
-	}
-	else if (approximation==PattynStokesApproximationEnum){
-		InputUpdateFromSolutionDiagnosticPattynStokes(solution);
-	}
-	else if (approximation==MacAyealStokesApproximationEnum){
-		InputUpdateFromSolutionDiagnosticMacAyealStokes(solution);
-	}
-	else if (approximation==StokesApproximationEnum || approximation==NoneApproximationEnum){
-		InputUpdateFromSolutionDiagnosticStokes(solution);
-	}
-	else if (approximation==MacAyealPattynApproximationEnum){
-		InputUpdateFromSolutionDiagnosticMacAyealPattyn(solution);
+	else if (approximation==HOApproximationEnum){
+		InputUpdateFromSolutionDiagnosticHO(solution);
+	}
+	else if (approximation==HOFSApproximationEnum){
+		InputUpdateFromSolutionDiagnosticHOFS(solution);
+	}
+	else if (approximation==MacAyealFSApproximationEnum){
+		InputUpdateFromSolutionDiagnosticMacAyealFS(solution);
+	}
+	else if (approximation==FSApproximationEnum || approximation==NoneApproximationEnum){
+		InputUpdateFromSolutionDiagnosticFS(solution);
+	}
+	else if (approximation==MacAyealHOApproximationEnum){
+		InputUpdateFromSolutionDiagnosticMacAyealHO(solution);
 	}
 }
@@ -9113,6 +9113,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticMacAyealPattyn {{{*/
-void  Penta::InputUpdateFromSolutionDiagnosticMacAyealPattyn(IssmDouble* solution){
+/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticMacAyealHO {{{*/
+void  Penta::InputUpdateFromSolutionDiagnosticMacAyealHO(IssmDouble* solution){
 
 	const int    numdof=NDOF2*NUMVERTICES;
@@ -9121,6 +9121,6 @@
 	int     i;
 	IssmDouble  rho_ice,g;
-	IssmDouble  macayeal_values[numdof];
-	IssmDouble  pattyn_values[numdof];
+	IssmDouble  SSA_values[numdof];
+	IssmDouble  HO_values[numdof];
 	IssmDouble  vx[NUMVERTICES];
 	IssmDouble  vy[NUMVERTICES];
@@ -9134,10 +9134,10 @@
 	Penta   *penta   = NULL;
 
-	/*OK, we have to add results of this element for pattyn 
-	 * and results from the penta at base for macayeal. Now recover results*/
+	/*OK, we have to add results of this element for HO 
+	 * and results from the penta at base for SSA. Now recover results*/
 	penta=GetBasalElement();
 
-	/*Get dof listof this element (pattyn dofs) and of the penta at base (macayeal dofs): */
-	GetDofList(&doflistp,PattynApproximationEnum,GsetEnum);
+	/*Get dof listof this element (HO dofs) and of the penta at base (SSA dofs): */
+	GetDofList(&doflistp,HOApproximationEnum,GsetEnum);
 	penta->GetDofList(&doflistm,MacAyealApproximationEnum,GsetEnum);
 
@@ -9147,20 +9147,20 @@
 	/*Use the dof list to index into the solution vector: */
 	for(i=0;i<numdof2d;i++){
-		pattyn_values[i]=solution[doflistp[i]];
-		macayeal_values[i]=solution[doflistm[i]];
+		HO_values[i]=solution[doflistp[i]];
+		SSA_values[i]=solution[doflistm[i]];
 	}
 	for(i=numdof2d;i<numdof;i++){
-		pattyn_values[i]=solution[doflistp[i]];
-		macayeal_values[i]=macayeal_values[i-numdof2d];
+		HO_values[i]=solution[doflistp[i]];
+		SSA_values[i]=SSA_values[i-numdof2d];
 	}
 
 	/*Transform solution in Cartesian Space*/
-	TransformSolutionCoord(&macayeal_values[0],penta->nodes,NUMVERTICES,XYEnum);
-	TransformSolutionCoord(&pattyn_values[0],   this->nodes,NUMVERTICES,XYEnum);
+	TransformSolutionCoord(&SSA_values[0],penta->nodes,NUMVERTICES,XYEnum);
+	TransformSolutionCoord(&HO_values[0],   this->nodes,NUMVERTICES,XYEnum);
 
 	/*Ok, we have vx and vy in values, fill in vx and vy arrays: */
 	for(i=0;i<NUMVERTICES;i++){
-		vx[i]=macayeal_values[i*NDOF2+0]+pattyn_values[i*NDOF2+0];
-		vy[i]=macayeal_values[i*NDOF2+1]+pattyn_values[i*NDOF2+1];
+		vx[i]=SSA_values[i*NDOF2+0]+HO_values[i*NDOF2+0];
+		vy[i]=SSA_values[i*NDOF2+1]+HO_values[i*NDOF2+1];
 
 		/*Check solution*/
@@ -9197,6 +9197,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticMacAyealStokes {{{*/
-void  Penta::InputUpdateFromSolutionDiagnosticMacAyealStokes(IssmDouble* solution){
+/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticMacAyealFS {{{*/
+void  Penta::InputUpdateFromSolutionDiagnosticMacAyealFS(IssmDouble* solution){
 
 	const int    numdofm=NDOF2*NUMVERTICES;
@@ -9205,12 +9205,12 @@
 
 	int     i;
-	IssmDouble  stokesreconditioning;
-	IssmDouble  macayeal_values[numdofm];
-	IssmDouble  stokes_values[numdofs];
+	IssmDouble  FSreconditioning;
+	IssmDouble  SSA_values[numdofm];
+	IssmDouble  FS_values[numdofs];
 	IssmDouble  vx[NUMVERTICES];
 	IssmDouble  vy[NUMVERTICES];
 	IssmDouble  vz[NUMVERTICES];
-	IssmDouble  vzmacayeal[NUMVERTICES];
-	IssmDouble  vzstokes[NUMVERTICES];
+	IssmDouble  vzSSA[NUMVERTICES];
+	IssmDouble  vzFS[NUMVERTICES];
 	IssmDouble  vel[NUMVERTICES];
 	IssmDouble  pressure[NUMVERTICES];
@@ -9220,12 +9220,12 @@
 	Penta   *penta          = NULL;
 
-	/*OK, we have to add results of this element for macayeal 
-	 * and results from the penta at base for macayeal. Now recover results*/
+	/*OK, we have to add results of this element for SSA 
+	 * and results from the penta at base for SSA. Now recover results*/
 	penta=GetBasalElement();
 
-	/*Get dof listof this element (macayeal dofs) and of the penta at base (macayeal dofs): */
+	/*Get dof listof this element (SSA dofs) and of the penta at base (SSA dofs): */
 	penta->GetDofList(&doflistm,MacAyealApproximationEnum,GsetEnum);
-	GetDofList(&doflists,StokesApproximationEnum,GsetEnum);
-	this->parameters->FindParam(&stokesreconditioning,DiagnosticStokesreconditioningEnum);
+	GetDofList(&doflists,FSApproximationEnum,GsetEnum);
+	this->parameters->FindParam(&FSreconditioning,DiagnosticFSreconditioningEnum);
 
 	/*Get node data: */
@@ -9234,36 +9234,36 @@
 	/*Use the dof list to index into the solution vector: */
 	for(i=0;i<numdof2d;i++){
-		macayeal_values[i]=solution[doflistm[i]];
-		macayeal_values[i+numdof2d]=solution[doflistm[i]];
+		SSA_values[i]=solution[doflistm[i]];
+		SSA_values[i+numdof2d]=solution[doflistm[i]];
 	}
 	for(i=0;i<numdofs;i++){
-		stokes_values[i]=solution[doflists[i]];
+		FS_values[i]=solution[doflists[i]];
 	}
 
 	/*Transform solution in Cartesian Space*/
-	TransformSolutionCoord(&macayeal_values[0],this->nodes,NUMVERTICES,XYEnum);
-	TransformSolutionCoord(&stokes_values[0],this->nodes,NUMVERTICES,XYZPEnum);
+	TransformSolutionCoord(&SSA_values[0],this->nodes,NUMVERTICES,XYEnum);
+	TransformSolutionCoord(&FS_values[0],this->nodes,NUMVERTICES,XYZPEnum);
 
 	/*Ok, we have vx and vy in values, fill in vx and vy arrays: */
 	for(i=0;i<NUMVERTICES;i++){
-		vx[i]=stokes_values[i*NDOF4+0]+macayeal_values[i*NDOF2+0];
-		vy[i]=stokes_values[i*NDOF4+1]+macayeal_values[i*NDOF2+1];
-		vzstokes[i]=stokes_values[i*NDOF4+2];
-		pressure[i]=stokes_values[i*NDOF4+3]*stokesreconditioning;
+		vx[i]=FS_values[i*NDOF4+0]+SSA_values[i*NDOF2+0];
+		vy[i]=FS_values[i*NDOF4+1]+SSA_values[i*NDOF2+1];
+		vzFS[i]=FS_values[i*NDOF4+2];
+		pressure[i]=FS_values[i*NDOF4+3]*FSreconditioning;
 
 		/*Check solution*/
 		if(xIsNan<IssmDouble>(vx[i]))       _error_("NaN found in solution vector");
 		if(xIsNan<IssmDouble>(vy[i]))       _error_("NaN found in solution vector");
-		if(xIsNan<IssmDouble>(vzstokes[i])) _error_("NaN found in solution vector");
+		if(xIsNan<IssmDouble>(vzFS[i])) _error_("NaN found in solution vector");
 		if(xIsNan<IssmDouble>(pressure[i])) _error_("NaN found in solution vector");
 	}
 
 	/*Get Vz*/
-	Input* vzmacayeal_input=inputs->GetInput(VzMacAyealEnum);
-	if (vzmacayeal_input){
-		if (vzmacayeal_input->ObjectEnum()!=PentaInputEnum){
-			_error_("Cannot compute Vel as VzMacAyeal is of type " << EnumToStringx(vzmacayeal_input->ObjectEnum()));
-		}
-		GetInputListOnVertices(&vzmacayeal[0],VzMacAyealEnum);
+	Input* vzSSA_input=inputs->GetInput(VzMacAyealEnum);
+	if (vzSSA_input){
+		if (vzSSA_input->ObjectEnum()!=PentaInputEnum){
+			_error_("Cannot compute Vel as VzMacAyeal is of type " << EnumToStringx(vzSSA_input->ObjectEnum()));
+		}
+		GetInputListOnVertices(&vzSSA[0],VzMacAyealEnum);
 	}
 	else{
@@ -9273,5 +9273,5 @@
 	/*Now Compute vel*/
 	for(i=0;i<NUMVERTICES;i++) {
-		vz[i]=vzmacayeal[i]+vzstokes[i];
+		vz[i]=vzSSA[i]+vzFS[i];
 		vel[i]=pow( pow(vx[i],2.0) + pow(vy[i],2.0) + pow(vz[i],2.0) , 0.5);
 	}
@@ -9288,5 +9288,5 @@
 	this->inputs->AddInput(new PentaInput(VyEnum,vy,P1Enum));
 	this->inputs->AddInput(new PentaInput(VzEnum,vz,P1Enum));
-	this->inputs->AddInput(new PentaInput(VzStokesEnum,vzstokes,P1Enum));
+	this->inputs->AddInput(new PentaInput(VzFSEnum,vzFS,P1Enum));
 	this->inputs->AddInput(new PentaInput(VelEnum,vel,P1Enum));
 	this->inputs->AddInput(new PentaInput(PressureEnum,pressure,P1Enum));
@@ -9378,6 +9378,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticPattyn {{{*/
-void  Penta::InputUpdateFromSolutionDiagnosticPattyn(IssmDouble* solution){
+/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticHO {{{*/
+void  Penta::InputUpdateFromSolutionDiagnosticHO(IssmDouble* solution){
 
 	const int    numdof=NDOF2*NUMVERTICES;
